/**
 *  zl 20220621 和地图相关的组件中 与map切换、获取、删除操作相关的部分都提取到这个对象
 *  map对象获取绑定的操作对象
 *  以组合式API提供给组件使用
 *  实现了map对象获取、加载监听、删除监听、销毁方法
 */

import mapEvent from "../_types/map-event";
// import gisUtils from "@/common/gis-utils";
// import globalEvent from "@/common/_utils/global-event";
// import Mitt from "@/common/_utils/mitt";
import { onMounted, onBeforeUnmount, nextTick, getCurrentInstance } from "vue";

export default function (mapTarget) {
  // 不包含二维模式时 不继续执行
  // if (gisUtils.getModel() === "cesium") {
  //   return;
  // }
  // let webmap = null; // mapview对象
  // let viewModel = null;
  //let mitt = new Mitt();

  const { proxy } = getCurrentInstance();

  // onMounted(() => {
  //   // const targetName = getTargetName();
  //   // if (!targetName) {
  //   //   console.log("未找到对应的二维地图元素");
  //   //   return;
  //   // }
  //   // if (mapEvent.getMap(targetName)) {
  //   //   loadMap(targetName);
  //   // }
  //   // // 添加map对象加载监听事件
  //   // mapEvent.mitt.on("load-map", loadMapSucceed);
  //   // // 添加map对象删除监听事件
  //   // globalEvent.on("delete-map", deleteMapSucceed);
  // });
  // onBeforeUnmount(() => {
  //   // mapEvent.mitt.off("load-map", loadMapSucceed);
  //   // globalEvent.off("delete-map", deleteMapSucceed);
  // });

  // function getWebMap(cb) {
  //   const targetName = getTargetName();
  //   let webmap = mapEvent.getWebMap(targetName);
  //   if (webmap) {
  //     cb(webmap);
  //   } else {
  //     // 添加map对象加载监听事件
  //     mapEvent.mitt.on("load-map", () => {
  //       webmap = mapEvent.getWebMap(targetName);
  //       if (webmap) {
  //         cb(webmap);
  //       }
  //     });
  //   }
  // }

  function getTargetName() {
    /**
     * 便于区分存在多个map时，子组件对应的map的渲染；
     * map 和 webmap  的 props 属性是 target 其他组件都叫 mapTarget
     * 如果子组件包裹在 map 组件里面，若没有传 mapTarget, 则 targetName 直接取父元素的target 的值
     * 如果子组件和 map 同层级，且没有设置 mapTarget 时，则默认渲染到第一个 map 上
     */
    const selfParent = proxy.$parent;
    const parentTarget =
      selfParent &&
      selfParent.$options.name &&
      selfParent.$options.name.toLowerCase() === "kqwebmap" &&
      selfParent.target;
    return mapTarget || parentTarget || Object.keys(mapEvent.getAllMaps())[0] || null;
  }

  // function loadMap(targetName) {
  //   webmap = mapEvent.getWebMap(targetName);
  //   //callHook(this, "loaded");
  //   // 控制与map组件同级的组件的显示加载
  //   nextTick(() => {
  //     /**
  //      * @event loaded
  //      * @desc 组件加载渲染完成之后触发，传递view对象。
  //      */
  //     mitt.fire("loaded", webmap);
  //   });
  // }
  // function loadMapSucceed(params) {
  //   const targetName = getTargetName();
  //   if (params.target === targetName) {
  //     loadMap(params.target);
  //   }
  // }
  // function deleteMapSucceed(target) {
  //   const targetName = getTargetName();
  //   if (target === targetName) {
  //     //callHook(this, "removed");
  //     webmap = null;
  //     viewModel && (viewModel = null);
  //   }
  // }

  //return { mitt };
}
