/**
 * ZL 20220606 mapview对象控制类，mapview对象控制类、删除、获取和mapview操作的监听事件处理mitt
 */
import Mitt from "@/common/_utils/mitt";

export default {
  webMapCache: {},
  // 事件监听对象
  mitt: new Mitt(),
  getWebMap: function (webmapTarget) {
    return this.webMapCache[webmapTarget];
  },
  getAllWebMap: function () {
    return this.webMapCache;
  },
  setWebMap: function (webmapTarget, webmap) {
    this.destroy();

    this.webMapCache[webmapTarget] = webmap;
  },
  deleteWebMap: function (webmapTarget) {
    delete this.webMapCache[webmapTarget];
  },
  // zl 为防止以特殊方式移除map的dom元素，但是map、mapview对象未销毁，
  // 特添加此方法，删除map对象绑定的div已经找不到的情况
  // 当前是为解决storybook频繁切换属性参数，组件不执行销毁的问题
  destroy() {
    Object.keys(this.webMapCache).forEach(key => {
      let target = this.webMapCache[key].target;
      // 绑定的div已经被移除
      if (!document.getElementById(target)) {
        this.webMapCache[key].destroy();

        //this.deleteMap(target);
        this.deleteWebMap(target);
      }
    });
  }
};
