import { utils } from "@/common/_utils/gis-utils";

let _data = [
  {
    name: "天地图-矢量（CGCS2000）",
    guid: 1000,
    className: "img1",
    epsg: "4490",
    children: [
      { name: "注记", serverType: "tianditu", layerType: "cva", isDegree: true, guid: "10001" },
      { name: "矢量", serverType: "tianditu", layerType: "vec", isDegree: true, guid: "10002" },
      { name: "地形晕染图", serverType: "tianditu", layerType: "ter", isDegree: true, guid: "10003" },
      { name: "地形中文注记", serverType: "tianditu", layerType: "cta", isDegree: true, guid: "10004" }
    ]
  },
  {
    name: "天地图-影像（CGCS2000）",
    guid: 1001,
    className: "img3",
    epsg: "4490",
    children: [
      { name: "注记", serverType: "tianditu", layerType: "cia", isDegree: true, guid: "10013" },
      { name: "影像", serverType: "tianditu", layerType: "img", isDegree: true, guid: "10014" }
    ]
  },
  {
    name: "天地图-矢量（球面墨卡托投影）",
    guid: 1002,
    className: "img4",
    epsg: "3857",
    children: [
      { name: "注记", serverType: "tianditu", layerType: "cva", guid: "10021" },
      { name: "矢量", serverType: "tianditu", layerType: "vec", guid: "10022" },
      { name: "地形晕染图", serverType: "tianditu", layerType: "ter", guid: "10023" },
      { name: "地形中文注记", serverType: "tianditu", layerType: "cta", guid: "10024" }
    ]
  },
  {
    name: "天地图-影像（球面墨卡托投影）",
    guid: 1003,
    className: "img2",
    epsg: "3857",
    children: [
      { name: "注记", serverType: "tianditu", layerType: "cia", guid: "10031" },
      { name: "影像", serverType: "tianditu", layerType: "img", guid: "10032" }
    ]
  },
  {
    name: "百度地图",
    guid: 1004,
    className: "img5",
    epsg: "3857",
    children: [
      { name: "全球矢量", layerType: "vec", serverType: "baidu", guid: "100401" },
      { name: "中国影像", layerType: "imgd", serverType: "baidu", guid: "100402" },
      { name: "全球注记", layerType: "imgz", serverType: "baidu", guid: "100403" },
      { name: "路况图", layerType: "time", serverType: "baidu", guid: "100404" },
      { name: "清新蓝", layerType: "light", serverType: "baidu", guid: "100405" },
      { name: "黑夜", layerType: "dark", serverType: "baidu", guid: "100406" },
      { name: "红色警戒", layerType: "redalert", serverType: "baidu", guid: "100407" },
      { name: "精简", layerType: "googlelite", serverType: "baidu", guid: "100408" },
      { name: "自然绿", layerType: "grassgreen", serverType: "baidu", guid: "100409" },
      { name: "浪漫粉", layerType: "pink", serverType: "baidu", guid: "100410" },
      { name: "青春绿", layerType: "darkgreen", serverType: "baidu", guid: "100411" },
      { name: "高端灰", layerType: "grayscale", serverType: "baidu", guid: "100412" },
      { name: "强边界", layerType: "hardedge", serverType: "baidu", guid: "100413" }
    ]
  },
  {
    name: "高德地图",
    guid: 1005,
    className: "img6",
    epsg: "3857",
    children: [
      { name: "全球矢量", layerType: "vec", serverType: "gaode", guid: "10051" },
      { name: "全球影像", layerType: "img", serverType: "gaode", guid: "10052" },
      { name: "影像注记", layerType: "cia", serverType: "gaode", guid: "10053" },
      { name: "道路标注纯图", layerType: "prd", serverType: "gaode", guid: "10054" },
      { name: "道路标注简图", layerType: "srd", serverType: "gaode", guid: "10055" },
      { name: "道路标注详图", layerType: "drd", serverType: "gaode", guid: "10056" },
      { name: "纯道路透明标注图", layerType: "tpr", serverType: "gaode", guid: "10057" },
      { name: "纯地标透明标注图", layerType: "tpm", serverType: "gaode", guid: "10058" }
    ]
  },
  {
    name: "腾讯地图",
    guid: 1006,
    className: "img7",
    epsg: "3857",
    children: [
      { name: "暗色调地图", layerType: "vec_ink", serverType: "tencent", guid: "10061" },
      { name: "经典地图", layerType: "vec_classic_1", serverType: "tencent", guid: "10062" },
      { name: "卫星图", layerType: "sate_tiles", serverType: "tencent", guid: "10063" },
      { name: "地形图", layerType: "dem_tiles", serverType: "tencent", guid: "10064" }
    ]
  },
  {
    name: "必应地图",
    guid: 1007,
    className: "img8",
    epsg: "3857",
    children: [
      { name: "Aerial", layerType: "Aerial", serverType: "bing", guid: "10071" },
      { name: "AerialWithLabels", layerType: "AerialWithLabels", serverType: "bing", guid: "10072" },
      { name: "AerialWithLabelsOnDemand", layerType: "AerialWithLabelsOnDemand", serverType: "bing", guid: "10073" },
      { name: "CanvasDark", layerType: "CanvasDark", serverType: "bing", guid: "10074" },
      { name: "CanvasLight", layerType: "CanvasLight", serverType: "bing", guid: "10075" },
      { name: "CanvasGray", layerType: "CanvasGray", serverType: "bing", guid: "10076" },
      { name: "Road", layerType: "Road", serverType: "bing", guid: "10077" },
      { name: "RoadOnDemand", layerType: "RoadOnDemand", serverType: "bing", guid: "10078" }
    ]
  },
  {
    name: "智图",
    guid: 1008,
    className: "img9",
    epsg: "3857",
    children: [
      { name: "彩色版", layerType: "ChinaOnlineCommunity", serverType: "geoq", guid: "10081" },
      { name: "蓝黑版", layerType: "ChinaOnlineStreetPurplishBlue", serverType: "geoq", guid: "10082" },
      { name: "灰色版", layerType: "ChinaOnlineStreetGray", serverType: "geoq", guid: "10083" },
      { name: "暖色版", layerType: "ChinaOnlineStreetWarm", serverType: "geoq", guid: "10084" },
      { name: "英文版", layerType: "ChinaOnlineCommunityENG", serverType: "geoq", guid: "10085" },
      { name: "移动版", layerType: "ChinaOnlineCommunity_Mobile", serverType: "geoq", guid: "10086" }
    ]
  },
  {
    name: "ArcGIS Online地图",
    guid: 1009,
    className: "img10",
    epsg: "3857",
    children: [
      {
        name: "ArcGisOnline-NatGeo_World_Map",
        layerType: "NatGeo_World_Map",
        serverType: "arcgisonline",
        guid: "10091"
      },
      { name: "ArcGisOnline-USA_Topo_Maps", layerType: "USA_Topo_Maps", serverType: "arcgisonline", guid: "10092" },
      { name: "ArcGisOnline-World_Imagery", layerType: "World_Imagery", serverType: "arcgisonline", guid: "10093" },
      {
        name: "ArcGisOnline-World_Physical_Map",
        layerType: "World_Physical_Map",
        serverType: "arcgisonline",
        guid: "10094"
      },
      {
        name: "ArcGisOnline-World_Shaded_Relief",
        layerType: "World_Shaded_Relief",
        serverType: "arcgisonline",
        guid: "10095"
      },
      {
        name: "ArcGisOnline-World_Street_Map",
        layerType: "World_Street_Map",
        serverType: "arcgisonline",
        guid: "10096"
      },
      {
        name: "ArcGisOnline-World_Terrain_Base",
        layerType: "World_Terrain_Base",
        serverType: "arcgisonline",
        guid: "10097"
      },
      { name: "ArcGisOnline-World_Topo_Map", layerType: "World_Topo_Map", serverType: "arcgisonline", guid: "10098" }
    ]
  },
  {
    name: "Mapbox地图",
    guid: 1010,
    className: "img11",
    epsg: "3857",
    children: [
      { name: "Mapbox Streets", layerType: "streets", serverType: "mapbox", guid: "10101" },
      { name: "Mapbox Outdoors", layerType: "outdoors", serverType: "mapbox", guid: "10102" },
      { name: "Mapbox Dark", layerType: "dark", serverType: "mapbox", guid: "10103" },
      { name: "Mapbox Light", layerType: "light", serverType: "mapbox", guid: "10104" },
      { name: "Mapbox Satellite", layerType: "satellite", serverType: "mapbox", guid: "10105" },
      { name: "Mapbox Satellite-Streets", layerType: "satellite-streets", serverType: "mapbox", guid: "10106" },
      { name: "Mapbox Navigation-Day", layerType: "navigation-day", serverType: "mapbox", guid: "10107" },
      { name: "Mapbox Satellite-Streets", layerType: "navigation-night", serverType: "mapbox", guid: "10108" }
    ]
  },
  {
    name: "OSM地图",
    guid: 1011,
    className: "img12",
    epsg: "3857",
    children: [
      { name: "OSM标准", layerType: "normal", serverType: "osm", guid: "10111" },
      { name: "OSM自行车地图", layerType: "bike", serverType: "osm", guid: "10112" },
      { name: "OSM交通地图", layerType: "transport", serverType: "osm", guid: "10113" },
      { name: "OSM人道主义地图", layerType: "humanitarian", serverType: "osm", guid: "10114" }
    ]
  }
];

export default class BasemapGalleryViewModel extends L.Evented {
  constructor(mapTarget) {
    super();

    this._mapTarget = mapTarget;

    this._loaded = this._loaded.bind(this);

    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {
    utils.getWebMap(this._mapTarget, this._loaded);
  }

  _loaded(webmap) {
    this._webMap = webmap;

    const info = this._webMap.getWebMapInfo();
    // 获取空间参考 过滤底图图层数据
    if (!info) {
      this._epsg = "3857";
    } else {
      this._epsg = info.spatialReference.epsg;
    }

    let that = this;
    _data.forEach(item => {
      if (that._epsg === 3857) {
        if (item.epsg === "3857") {
          item.disabled = false;
        } else {
          item.disabled = true;
        }
      } else if (that._epsg === 4490 || that._epsg === 4326) {
        if (item.epsg === "4490") {
          item.disabled = false;
        } else {
          item.disabled = true;
        }
      } else {
        item.disabled = true;
      }
    });

    this.fire("setData", { data: _data });
  }

  rowClick(item) {
    let key = item.serverType + "_" + item.layerType;
    let layerConfig = { serverType: item.serverType, layerType: item.layerType, guid: key };
    if (item.isDegree) {
      layerConfig.guid += "_2000";
      layerConfig.isDegree = item.isDegree;
    }
    this._webMap.showOnlineBaseLayer(layerConfig, item.visible);
  }

  removeAllLayers() {
    this._webMap.removeAllOnlineBaseLayer();
  }

  destroy() {
    this.off();
    this.removeAllLayers();
  }
}
