import { lang, setLocale } from "@/common/_lang";
import { setTheme } from "@/common/_utils/style/theme/setTheme";

import CommonComponents from "@/common/index";
export * from "@/common/index";
import KqBaseWindow from "@/common/basewindow";

import KqMapView from "@/leaflet/mapview";
import { MapViewViewModel as KqMapViewViewModel } from "@/leaflet/mapview";

import Kq2dMeasure from "@/leaflet/measure";
import { MeasureViewModel as Kq2dMeasureViewModel } from "@/leaflet/measure";

import Kq2dRoller from "@/leaflet/roller";
import { RollerViewModel as Kq2dRollerViewModel } from "@/leaflet/roller";

import KqPan from "@/leaflet/mapcommontools";

import Kq2dStatusBar from "@/leaflet/statusbar";
import { StatusBarViewModel as Kq2dStatusBarViewModel } from "@/leaflet/statusbar";

import {
  FullExtent as KqFullExtent,
  FixedZoomin as KqFixedZoomin,
  FixedZoomout as KqFixedZoomout,
  Zoomout as KqZoomout,
  Zoomin as KqZoomin,
  PreviousExtent as Kq2dPreviousExtent,
  NextExtent as Kq2dNextExtent,
  Clear as KqClear
} from "@/leaflet/mapcommontools";

import Kq2dCompareMap from "@/leaflet/comparemap";
import { CompareMapTree as Kq2dCompareMapTree } from "@/leaflet/comparemap";
import { CompareMapViewModel as Kq2dCompareMapViewModel } from "@/leaflet/comparemap";
import { MapCompareViewModel as Kq2dMapCompareViewModel } from "@/leaflet/comparemap";

import Kq2dScaleLocation from "@/leaflet/scalelocation";
import { ScaleLocationViewModel as Kq2dScaleLocationViewModel } from "@/leaflet/scalelocation";

import Kq2dFilterDetail from "@/leaflet/filterdetail";
import { FilterDetailViewModel as Kq2dFilterDetailViewModel } from "@/leaflet/filterdetail";

import Kq2dScale from "@/leaflet/scale";
import { ScaleViewModel as Kq2dScaleViewModel } from "@/leaflet/scale";

import Kq2dScreenshot from "@/leaflet/screenshot";

import Kq2dAddData from "@/leaflet/adddata";
import { AddDataViewModel as Kq2dAddDataViewModel } from "@/leaflet/adddata";

import Kq2dBasemapGallery from "@/leaflet/basemapgallery";
import { BasemapGalleryViewModel as Kq2dBasemapGalleryViewModel } from "@/leaflet/basemapgallery";

// import Kq2dHawkeye from "@/leaflet/hawkeye";
import { hawkeye1 as kq2dHawkeye1 } from "@/leaflet/hawkeye";

import Kq2dPrint from "@/leaflet/print";
import { PrintViewModel as Kq2dPrintViewModel } from "@/leaflet/print";

const components = {
  KqBaseWindow,
  KqMapView,
  Kq2dMeasure,
  Kq2dRoller,
  KqPan,
  KqFullExtent,
  KqFixedZoomin,
  KqFixedZoomout,
  KqZoomout,
  KqZoomin,
  Kq2dPreviousExtent,
  Kq2dNextExtent,
  KqClear,
  Kq2dCompareMap,
  Kq2dCompareMapTree,
  Kq2dStatusBar,
  Kq2dScaleLocation,
  Kq2dFilterDetail,
  Kq2dScreenshot,
  Kq2dScale,
  Kq2dBasemapGallery,
  // Kq2dHawkeye,
  Kq2dAddData,
  Kq2dPrint
};
// 全局引入
const install = function (Vue, opts = {}) {
  for (const component in components) {
    if (!["KqNotification", "KqMessage"].includes(component)) {
      const com = components[component];
      Vue.use(com, opts);
    }
  }
  CommonComponents.install(Vue, opts);
};

export {
  KqMapView,
  KqMapViewViewModel,
  Kq2dMeasure,
  Kq2dMeasureViewModel,
  Kq2dRoller,
  Kq2dRollerViewModel,
  KqPan,
  KqFullExtent,
  KqFixedZoomin,
  KqFixedZoomout,
  KqZoomout,
  KqZoomin,
  Kq2dPreviousExtent,
  Kq2dNextExtent,
  KqClear,
  Kq2dCompareMap,
  Kq2dCompareMapTree,
  Kq2dCompareMapViewModel,
  Kq2dMapCompareViewModel,
  Kq2dStatusBar,
  Kq2dStatusBarViewModel,
  Kq2dScaleLocation,
  Kq2dScaleLocationViewModel,
  Kq2dFilterDetail,
  Kq2dFilterDetailViewModel, 
  Kq2dScale,
  Kq2dScaleViewModel,
  Kq2dScreenshot,
  Kq2dAddData,
  Kq2dAddDataViewModel,
  Kq2dBasemapGallery,
  Kq2dBasemapGalleryViewModel,
  // Kq2dHawkeye,
  // Kq2dHawkeyeViewModel,
  kq2dHawkeye1,
  Kq2dPrint,
  Kq2dPrintViewModel
};

export default {
  install,
  lang,
  locale: setLocale,
  setTheme
};
