import { utils } from "@/common/_utils/gis-utils";

export default class HawkeyeViewModel extends L.Evented {
  constructor() {
    super();

    this._loaded = this._loaded.bind(this);
  }

  init() {
    utils.getWebMap(this._mapTarget, this._loaded);
  }

  _loaded(webmap) {
    this._webMap = webmap;

    this.start();

    this.fire("webMapMounted");
  }

  start() {
    this._webMap.mapControl.startMiniMap();
  }

  changeLayer() {}

  bindEvents(type, fn) {
    this._webMap.mapControl.miniMap.on(type, fn);
  }

  destroy() {
    this.off();
    this._webMap.mapControl.miniMap.off();
  }
}
