import { utils } from "@/common/_utils/gis-utils";

export default class CommonToolsViewModel extends window.L.Evented {
  _webMap = null;
  constructor() {
    super();

    this._loaded = this._loaded.bind(this);

    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {
    // if (!this._mapTarget) {
    //   utils.getTargetName("leaflet", mt => {
    //     this._mapTarget = mt;
    //     if (!this._mapTarget) {
    //       console.error("未找到绑定的地图对象");
    //       return;
    //     }
    //     utils.getWebMap("leaflet", this._loaded, this._mapTarget);
    //   });
    // } else {
    //   utils.getWebMap("leaflet", this._loaded, this._mapTarget);
    // }
    utils.getWebMap(this._mapTarget, this._loaded);
  }
  _loaded(webmap) {
    this._webMap = webmap;
  }

  operate(type) {
    if (!this._webMap) return;

    switch (type) {
      case "pan": {
        this._webMap.pan();
        break;
      }
      case "fullextent": {
        this._webMap.fullExtent();
        break;
      }
      case "fixedzoomout": {
        this._webMap.map.zoomOut();
        break;
      }
      case "fixedzoomin": {
        this._webMap.map.zoomIn();
        break;
      }
      case "zoomout": {
        this._webMap.startLKSX();
        break;
      }
      case "zoomin": {
        this._webMap.startLKFD();
        break;
      }
      case "previous": {
        this._webMap.history.goBack();
        break;
      }
      case "next": {
        this._webMap.history.goForward();
        break;
      }
      case "clear": {
        this._webMap.mapDraw.removeAllGeometry();
        break;
      }
    }
  }

  // 销毁
  destroy() {
    // 删除所有事件监听
    this.off();
  }
}
