"use strict";
const Swipe = {
  target: null,
  map: null,
  // 顶层卷帘图层
  maptoplayerdiv: null,
  // 卷帘方式
  type: "right",
  // 鼠标是否按下
  isDown: false,
  // 是否正在卷帘
  isSwipe: false,
  // 3等份x
  x_3: 0,
  // 3等份y
  y_3: 0,
  context: null,
  lineCanvas: null,
  mapSize: null,
  rect: null,
  /** 开始卷帘
   * @param map 地图对象
   * @param _map1toplayerdiv 图层顶层的layer的div对象
   */
  startSwipe: function (_target, _map, _map1toplayerdiv) {
    this.map = _map;
    this.target = _target;
    this.maptoplayerdiv = _map1toplayerdiv;
    this.type = "";
    this.isDown = false;
    this.isSwipe = true;

    // map的大小
    this.mapSize = { x: this.map._container.clientWidth, y: this.map._container.clientHeight }; // this.map.getSize();
    // 计算x与y的3等份
    this.x_3 = this.mapSize.x / 3;
    this.y_3 = this.mapSize.y / 3;
    document.getElementById(this.target).addEventListener("mousemove", this.mapMove);
    document.getElementById(this.target).addEventListener("mousedown", this.mapDown);
    document.getElementById(this.target).addEventListener("mouseup", this.mapUp);

    this.lineCanvas = document.createElement("canvas");
    this.lineCanvas.id = "swipeLine";
    this.lineCanvas.style.position = "absolute";
    this.lineCanvas.style.top = "0px";
    this.lineCanvas.style.left = "0px";
    this.lineCanvas.style.zIndex = "998";
    this.lineCanvas.width = document.getElementById(this.target).offsetWidth;
    this.lineCanvas.height = document.getElementById(this.target).offsetHeight;
    this.rect = !this.rect ? document.getElementById(this.target).getBoundingClientRect() : this.rect;
    this.context = this.lineCanvas.getContext("2d");

    this.context.beginPath();
    this.context.lineTo(0, 0);
    this.context.lineTo(this.lineCanvas.width, 0);
    this.context.lineTo(this.lineCanvas.width, this.lineCanvas.height);
    this.context.lineTo(0, this.lineCanvas.height);
    this.context.fillStyle = "rgba(91, 90, 90, 0.1)"; //内部使用浅灰色
    this.context.fill();
    document.getElementById(this.target).appendChild(this.lineCanvas);
  },
  /**
   * 停止卷帘
   */
  stopSwipe: function () {
    this.isSwipe = false;  
    var _targetDom = document.getElementById(this.target);
    _targetDom && _targetDom.removeEventListener("mousemove", this.mapMove);
    _targetDom && _targetDom.removeEventListener("mousedown", this.mapDown);
    _targetDom && _targetDom.removeEventListener("mouseup", this.mapUp);
    _targetDom && (_targetDom.style.cursor = "default");
    // document.body.style.cursor = "auto";

    if (this.maptoplayerdiv !== null) {
      this.maptoplayerdiv.style.clip = "auto";
      this.maptoplayerdiv.style.clipPath = "none";
    }
    if (this.lineCanvas !== null) {
      try {
        document.getElementById(this.target).removeChild(this.lineCanvas);
      } catch (e) {}
    }
  },
  mapDown: function () {
    Swipe.isDown = true;
    Swipe.map.dragging.disable();
  },
  mapUp: function () {
    Swipe.isDown = false;
    Swipe.map.dragging.enable();
  },
  mapMove: function () {
    let _this = Swipe;
    let moveX = event.pageX - _this.rect.x;
    let moveY = event.pageY - _this.rect.y;
    let type = "";
    let cursor = "auto";
    if (!_this.isDown) {
      if (moveX <= _this.x_3 && moveY <= _this.y_3) {
        type = "left_top";
        cursor = "nw-resize";
      } else if (moveX > _this.x_3 && moveX <= _this.x_3 * 2 && moveY <= _this.y_3) {
        type = "top";
        cursor = "n-resize";
      } else if (moveX > _this.x_3 * 2 && moveX <= _this.x_3 * 3 && moveY <= _this.y_3) {
        type = "right_top";
        cursor = "ne-resize";
      } else if (moveX <= _this.x_3 && moveY > _this.y_3 && moveY <= _this.y_3 * 2) {
        type = "left";
        cursor = "e-resize";
      } else if (moveX > _this.x_3 * 2 && moveX <= _this.x_3 * 3 && moveY > _this.y_3 && moveY <= _this.y_3 * 2) {
        type = "right";
        cursor = "e-resize";
      } else if (moveX <= _this.x_3 && moveY > _this.y_3 * 2) {
        type = "left_bottom";
        cursor = "ne-resize";
      } else if (moveX > _this.x_3 && moveX <= _this.x_3 * 2 && moveY > _this.y_3 * 2) {
        type = "bottom";
        cursor = "n-resize";
      } else if (moveX > _this.x_3 * 2 && moveX <= _this.x_3 * 3 && moveY > _this.y_3 * 2) {
        type = "right_bottom";
        cursor = "nw-resize";
      } else {
        if (moveX <= _this.x_3 + _this.x_3 / 2) {
          type = "left";
          cursor = "e-resize";
        } else {
          type = "right";
          cursor = "e-resize";
        }
      }
      if (type !== _this.type) {
        document.getElementById(_this.target).style.cursor = cursor;
        // document.body.style.cursor = cursor;
        _this.type = type;
      }
    } else {
      _this.clipMap(_this.type, moveX, moveY);
    }
  },
  clipMap: function (type, moveX, moveY) {
    // 中心点
    let point = Swipe.map.containerPointToLayerPoint([0, 0]);
    // 大小
    let size = Swipe.map.containerPointToLayerPoint(this.mapSize);
    // 按钮的位置与大小
    let left = moveX;
    let top = moveY;
    // map的大小
    let mapWidth = size.x - point.x;
    let mapHeight = size.y - point.y;
    let cliptop = point.y;
    let clipleft = point.x;
    let clipbottom = size.y;
    let clipright = size.x;
    let polygon = "";
    let xieMove = 0;
    let point1 = "";
    let point2 = "";
    let point3 = "";
    let point4 = "";
    let point5 = "";

    let beginPoint = {}; // 分割线起始点
    let endPoint = {}; // 分割线结束点
    let ploygon = []; // 遮罩坐标点
    switch (type) {
      // 右下角
      case "right_bottom":
        // xieMove = ((clipright - (left + clipleft)) + (clipbottom - (top + cliptop))) / 2 - (btnWidth / 2);
        xieMove = mapWidth - left + (mapHeight - top); // - (btnWidth / 2) - 6;
        point1 = clipleft + "px " + cliptop + "px";
        point2 = clipright + "px " + cliptop + "px";
        point3 = clipright + "px " + (clipbottom - xieMove) + "px";
        point4 = clipright - xieMove + "px " + clipbottom + "px";
        point5 = clipleft + "px " + clipbottom + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + "," + point5 + ")";

        endPoint = { x: mapWidth, y: mapHeight - xieMove };
        beginPoint = { x: mapWidth - xieMove, y: mapHeight };
        ploygon.push({ x: 0, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: 0 });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        ploygon.push({ x: 0, y: Swipe.lineCanvas.height });
        break;
      // 右上角
      case "right_top":
        // 计算拖动x与y的距离
        xieMove = mapWidth - left + top;
        point1 = clipleft + "px " + cliptop + "px";
        point2 = clipright - xieMove + "px " + cliptop + "px";
        point3 = clipright + "px " + (cliptop + xieMove) + "px";
        point4 = clipright + "px " + clipbottom + "px";
        point5 = clipleft + "px " + clipbottom + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + "," + point5 + ")";

        beginPoint = { x: mapWidth - xieMove, y: 0 };
        endPoint = { x: mapWidth, y: xieMove };
        ploygon.push({ x: 0, y: 0 });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: Swipe.lineCanvas.width, y: Swipe.lineCanvas.height });
        ploygon.push({ x: 0, y: Swipe.lineCanvas.height });
        break;
      // 左下角
      case "left_bottom":
        xieMove = left + (mapHeight - top); // - (btnWidth / 4);
        point1 = clipleft + "px " + cliptop + "px";
        point2 = clipright + "px " + cliptop + "px";
        point3 = clipright + "px " + clipbottom + "px";
        point4 = clipleft + xieMove + "px " + clipbottom + "px";
        point5 = clipleft + "px " + (clipbottom - xieMove) + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + "," + point5 + ")";

        beginPoint = { x: 0, y: mapHeight - xieMove };
        endPoint = { x: xieMove, y: mapHeight };
        ploygon.push({ x: 0, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: Swipe.lineCanvas.height });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        break;
      // 左上角
      case "left_top":
        xieMove = left + top; // + (btnWidth / 2);
        point1 = clipleft + xieMove + "px " + cliptop + "px";
        point2 = clipright + "px " + cliptop + "px";
        point3 = clipright + "px " + clipbottom + "px";
        point4 = clipleft + "px " + clipbottom + "px";
        point5 = clipleft + "px " + (cliptop + xieMove) + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + "," + point5 + ")";

        endPoint = { x: xieMove, y: 0 };
        beginPoint = { x: 0, y: xieMove };
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: Swipe.lineCanvas.width, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: Swipe.lineCanvas.height });
        ploygon.push({ x: 0, y: Swipe.lineCanvas.height });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        break;
      // 右边
      case "right":
        // 计算拖动x与y的距离
        xieMove = mapWidth - left; // - (btnWidth / 2);
        point1 = clipleft + "px " + cliptop + "px";
        point2 = clipright - xieMove + "px " + cliptop + "px";
        point3 = clipright - xieMove + "px " + clipbottom + "px";
        point4 = clipleft + "px " + clipbottom + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + ")";

        beginPoint = { x: left, y: 0 };
        endPoint = { x: left, y: mapHeight };
        ploygon.push({ x: 0, y: 0 });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: 0, y: Swipe.lineCanvas.height });
        break;
      // 左边
      case "left":
        // 计算拖动x与y的距离
        xieMove = left; // + (btnWidth / 2);
        point1 = clipleft + xieMove + "px " + cliptop + "px";
        point2 = clipright + "px " + cliptop + "px";
        point3 = clipright + "px " + clipbottom + "px";
        point4 = clipleft + xieMove + "px " + clipbottom + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + ")";

        beginPoint = { x: left, y: 0 };
        endPoint = { x: left, y: mapHeight };
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        ploygon.push({ x: Swipe.lineCanvas.width, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: Swipe.lineCanvas.height });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        break;
      // 左边
      case "top":
        // 计算拖动x与y的距离
        xieMove = top; // + (btnWidth / 2);
        point1 = clipleft + "px " + (cliptop + xieMove) + "px";
        point2 = clipright + "px " + (cliptop + xieMove) + "px";
        point3 = clipright + "px " + clipbottom + "px";
        point4 = clipleft + "px " + clipbottom + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + ")";

        beginPoint = { x: 0, y: top };
        endPoint = { x: mapWidth, y: top };
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: Swipe.lineCanvas.width, y: Swipe.lineCanvas.height });
        ploygon.push({ x: 0, y: Swipe.lineCanvas.height });
        break;
      // 左边
      case "bottom":
        // 计算拖动x与y的距离
        xieMove = mapHeight - top;
        point1 = clipleft + "px " + cliptop + "px";
        point2 = clipright + "px " + cliptop + "px";
        point3 = clipright + "px " + (clipbottom - xieMove) + "px";
        point4 = clipleft + "px " + (clipbottom - xieMove) + "px";
        polygon = "polygon(" + point1 + "," + point2 + "," + point3 + "," + point4 + ")";

        beginPoint = { x: 0, y: top };
        endPoint = { x: mapWidth, y: top };
        ploygon.push({ x: 0, y: 0 });
        ploygon.push({ x: Swipe.lineCanvas.width, y: 0 });
        ploygon.push({ x: endPoint.x, y: endPoint.y });
        ploygon.push({ x: beginPoint.x, y: beginPoint.y });
        break;
    }
    /*
        // 坐标值小于0与大于最大范围的重置坐标
        if (beginPoint.x > Swipe.lineCanvas.width) {
            beginPoint.y = beginPoint.y - (beginPoint.x - Swipe.lineCanvas.width);
            beginPoint.x = Swipe.lineCanvas.width;
        }
        if (beginPoint.y > Swipe.lineCanvas.height) {
            if (type === 'left_top') {
                beginPoint.x = beginPoint.x + (beginPoint.y - Swipe.lineCanvas.height);
            } else {
                beginPoint.x = beginPoint.x - (beginPoint.y - Swipe.lineCanvas.height);
            }
            beginPoint.y = Swipe.lineCanvas.height;
        }
        if (endPoint.x > Swipe.lineCanvas.width) {
            if (type === 'left_top') {
                endPoint.y = endPoint.y + (endPoint.x - Swipe.lineCanvas.width);
            } else {
                endPoint.y = endPoint.y - (endPoint.x - Swipe.lineCanvas.width);
            }
            endPoint.x = Swipe.lineCanvas.width;
        }
        if (endPoint.y > Swipe.lineCanvas.height) {
            endPoint.x = endPoint.x - (endPoint.y - Swipe.lineCanvas.height);
            endPoint.y = Swipe.lineCanvas.height;
        }
        if (beginPoint.x < 0) {
            if (type === 'right_top') {
                beginPoint.y = beginPoint.y - beginPoint.x;
            } else {
                beginPoint.y = beginPoint.y + beginPoint.x;
            }
            beginPoint.x = 0;
        }
        if (beginPoint.y < 0) {
            beginPoint.x = beginPoint.x - beginPoint.y;
            beginPoint.y = 0;
        }
        if (endPoint.x < 0) {
            endPoint.y = endPoint.y - endPoint.x;
            endPoint.x = Swipe.lineCanvas.width;
        }
        if (endPoint.y < 0) {
            endPoint.x = endPoint.x + endPoint.y;
            endPoint.y = 0;
        }
        // 方法1, 始终在中心点上
        let centerPoint = [(beginPoint.x + endPoint.x) / 2, (beginPoint.y + endPoint.y) / 2];
        */
    // 方法2, 跟随鼠标点
    let centerPoint = [left, top];
    // 计算左线与右边坐标
    let centerLinePoint1 = this.getArrowLocationPos(centerPoint, [beginPoint.x, beginPoint.y], 20);
    let centerLinePoint2 = this.getArrowLocationPos(centerPoint, [endPoint.x, endPoint.y], 20);
    let leftLinePoint1 = this.calcNodeLineEndPoint(
      centerLinePoint1,
      centerLinePoint2,
      centerLinePoint2,
      Math.PI / 2,
      7
    );
    let leftLinePoint2 = this.calcNodeLineEndPoint(
      centerLinePoint1,
      centerLinePoint2,
      centerLinePoint1,
      Math.PI / 2,
      7
    );
    let rightLinePoint1 = this.calcNodeLineEndPoint(
      centerLinePoint1,
      centerLinePoint2,
      centerLinePoint2,
      Math.PI / 2,
      -7
    );
    let rightLinePoint2 = this.calcNodeLineEndPoint(
      centerLinePoint1,
      centerLinePoint2,
      centerLinePoint1,
      Math.PI / 2,
      -7
    );

    Swipe.maptoplayerdiv.style.clipPath = polygon;
    Swipe.context.clearRect(0, 0, mapWidth, mapHeight);
    Swipe.context.beginPath();
    Swipe.context.strokeStyle = "#3388ff";
    Swipe.context.lineWidth = 2;
    // 绘制中心线
    Swipe.context.moveTo(beginPoint.x, beginPoint.y);
    Swipe.context.lineTo(endPoint.x, endPoint.y);
    // 绘制左右线
    this.drawLeftRightLine(leftLinePoint1, leftLinePoint2, rightLinePoint1, rightLinePoint2, 2);
    Swipe.context.closePath();
    Swipe.context.stroke();

    // 绘制遮罩
    Swipe.context.beginPath();
    Swipe.context.shadowBlur = 0;
    for (let i = 0; i < ploygon.length; i++) {
      Swipe.context.lineTo(ploygon[i].x, ploygon[i].y);
    }
    Swipe.context.fillStyle = "rgba(91, 90, 90, 0.3)"; //内部使用浅灰色 0.15
    Swipe.context.fill();
  },
  drawLeftRightLine: function (leftLinePoint1, leftLinePoint2, rightLinePoint1, rightLinePoint2, sum) {
    if (sum === 1) {
      // 绘制左线
      Swipe.context.moveTo(leftLinePoint1[0], leftLinePoint1[1]);
      Swipe.context.lineTo(leftLinePoint2[0], leftLinePoint2[1]);
      // 绘制右线
      Swipe.context.moveTo(rightLinePoint1[0], rightLinePoint1[1]);
      Swipe.context.lineTo(rightLinePoint2[0], rightLinePoint2[1]);
    } else if (sum === 2) {
      // 绘制左线
      let p1 = this.getArrowLocationPos(
        [leftLinePoint1[0], leftLinePoint1[1]],
        [leftLinePoint2[0], leftLinePoint2[1]],
        18
      );
      let p2 = this.getArrowLocationPos(
        [leftLinePoint2[0], leftLinePoint2[1]],
        [leftLinePoint1[0], leftLinePoint1[1]],
        18
      );
      Swipe.context.moveTo(leftLinePoint1[0], leftLinePoint1[1]);
      Swipe.context.lineTo(p1[0], p1[1]);
      Swipe.context.moveTo(leftLinePoint2[0], leftLinePoint2[1]);
      Swipe.context.lineTo(p2[0], p2[1]);
      // 绘制右线
      p1 = this.getArrowLocationPos(
        [rightLinePoint1[0], rightLinePoint1[1]],
        [rightLinePoint2[0], rightLinePoint2[1]],
        18
      );
      p2 = this.getArrowLocationPos(
        [rightLinePoint2[0], rightLinePoint2[1]],
        [rightLinePoint1[0], rightLinePoint1[1]],
        18
      );
      Swipe.context.moveTo(rightLinePoint1[0], rightLinePoint1[1]);
      Swipe.context.lineTo(p1[0], p1[1]);
      Swipe.context.moveTo(rightLinePoint2[0], rightLinePoint2[1]);
      Swipe.context.lineTo(p2[0], p2[1]);
    } else if (sum === 3) {
      // 绘制左线
      let p1 = this.getArrowLocationPos(
        [leftLinePoint1[0], leftLinePoint1[1]],
        [leftLinePoint2[0], leftLinePoint2[1]],
        12
      );
      let p2 = this.getArrowLocationPos(
        [leftLinePoint1[0], leftLinePoint1[1]],
        [leftLinePoint2[0], leftLinePoint2[1]],
        14
      );
      let p3 = this.getArrowLocationPos(
        [leftLinePoint1[0], leftLinePoint1[1]],
        [leftLinePoint2[0], leftLinePoint2[1]],
        26
      );
      let p4 = this.getArrowLocationPos(
        [leftLinePoint1[0], leftLinePoint1[1]],
        [leftLinePoint2[0], leftLinePoint2[1]],
        28
      );
      Swipe.context.moveTo(leftLinePoint1[0], leftLinePoint1[1]);
      Swipe.context.lineTo(p1[0], p1[1]);
      Swipe.context.moveTo(p2[0], p2[1]);
      Swipe.context.lineTo(p3[0], p3[1]);
      Swipe.context.moveTo(p4[0], p4[1]);
      Swipe.context.lineTo(leftLinePoint2[0], leftLinePoint2[1]);
      // 绘制右线
      p1 = this.getArrowLocationPos(
        [rightLinePoint1[0], rightLinePoint1[1]],
        [rightLinePoint2[0], rightLinePoint2[1]],
        12
      );
      p2 = this.getArrowLocationPos(
        [rightLinePoint1[0], rightLinePoint1[1]],
        [rightLinePoint2[0], rightLinePoint2[1]],
        14
      );
      p3 = this.getArrowLocationPos(
        [rightLinePoint1[0], rightLinePoint1[1]],
        [rightLinePoint2[0], rightLinePoint2[1]],
        26
      );
      p4 = this.getArrowLocationPos(
        [rightLinePoint1[0], rightLinePoint1[1]],
        [rightLinePoint2[0], rightLinePoint2[1]],
        28
      );
      Swipe.context.moveTo(rightLinePoint1[0], rightLinePoint1[1]);
      Swipe.context.lineTo(p1[0], p1[1]);
      Swipe.context.moveTo(p2[0], p2[1]);
      Swipe.context.lineTo(p3[0], p3[1]);
      Swipe.context.moveTo(p4[0], p4[1]);
      Swipe.context.lineTo(rightLinePoint2[0], rightLinePoint2[1]);
    }
  },
  getArrowLocationPos: function (p1, p2, length) {
    let deltaX = p2[0] - p1[0];
    let deltaY = p2[1] - p1[1];
    let distance = Math.sqrt(deltaX * deltaX + deltaY * deltaY);
    let cosa = deltaX / distance;
    let sina = deltaY / distance;
    return [p1[0] + length * cosa, p1[1] + length * sina];
  },
  calcNodeLineEndPoint: function (p1, p2, SP, angle, length) {
    let deltaX = p2[0] - p1[0];
    let deltaY = p2[1] - p1[1];
    let distance = Math.sqrt(deltaX * deltaX + deltaY * deltaY);
    if (distance === 0) {
      return [];
    }
    let cosa = deltaX / distance;
    let sina = deltaY / distance;

    let dis1 = this.distance(p1, SP) - Math.cos(angle) * length;
    let length2 = Math.sin(angle) * length;

    let SPX = p1[0] + dis1 * cosa;
    let SPY = p1[1] + dis1 * sina;

    return [SPX - length2 * sina, SPY + length2 * cosa];
  },
  distance: function (pnt1, pnt2) {
    return Math.sqrt(Math.pow(pnt1[0] - pnt2[0], 2) + Math.pow(pnt1[1] - pnt2[1], 2));
  }
};
export default Swipe;
