import Mitt from "@/common/_utils/mitt";
import { utils } from "@/common/_utils/gis-utils";

export default class MeasureViewModel extends Mitt {
  _props = null;
  _webMap = null;

  constructor(mapTarget) {
    super();
    this._props = { mapTarget };
    // 事件绑定this
    this._loaded = this._loaded.bind(this);
    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {    
    utils.getWebMap(this._props.mapTarget, this._loaded);
  }

  _loaded(e) {    
    this._webMap = e;
  }

  /**
   * 清除测量绘图
   */
  clearMeasure() {
    if (this._webMap) {
      document.getElementById(this._webMap.target).style.cursor = "grab";
      this._webMap.mapDraw.removeAllLayerFromMeasure();
    }
  }

  /**
   * 面积测量
   */
  areaMeasure(callFun, type, options) {
    this.clearMeasure();
    this._webMap.mapDraw.startMeasure(callFun, type, options);
  }

  /**
   * 距离测量
   */
  distanceMeasure(callFun, type, options) {
    this.clearMeasure();
    this._webMap.mapDraw.startMeasure(callFun, type, options);
  }
}
