import Mitt from "@/common/_utils/mitt";
import { mapViewUtils } from "@/common/_utils/gis-utils";
import { utils } from "@/common/_utils/gis-utils";

export default class PrintViewModel extends Mitt {
  _props = null;
  webMap = null;
  constructor(options) {
    super();
    this._props = options.props;
    // 事件绑定this
    this._loadedSync = this._loadedSync.bind(this);
    // this.setLayerData = this.setLayerData.bind(this);
    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {
    // mapview初始化结束监听 如果view已经存在了，mounted事件不会添加监听
    mapViewUtils.bindViewEvents("mounted", this._loadedAsync, this._mapTarget);
    // 添加图层数据源变化监听
    mapViewUtils.bindViewEvents("resetLayerDatas", this._loadedAsync, this._mapTarget);
  }

  _loadedAsync(e) {
    // 如果图层变化事件是自己触发的 则不继续执行 避免死循环
    if (e.eventTarget && e.eventTarget === this) {
      return;
    }
    this.webMap = e.target;
  }

  // _loadedAsync(e) {
  //   // 如果图层变化事件是自己触发的 则不继续执行 避免死循环
  //   if (e.eventTarget && e.eventTarget === this) {
  //     return;
  //   }
  //   this.webMap = e.target;
  //   this.setLayerData();
  //   this.getWebMap();
  // }

  _loadedSync(e) {
    this.webMap = e;
    this.getWebMap();
    // this.setLayerData();
  }

  openPrint() {
    utils.getWebMap(this._props.mapTarget, this._loadedSync);
  }
  /**
   * 获取webmap
   */
  getWebMap() {
    let layerinfo = null;
    if (this.webMap._props.baseLayerInfo) {
      layerinfo = mapViewUtils.getBaseLayerInfo(this._props.mapTarget);
    }
    this.fire("getWebMap", { webMap: this.webMap, baseLayerInfo: layerinfo });
  }

  setShowBaseLayer() {
    let layerinfo = mapViewUtils.getMapBaseLayerData(this._props.mapTarget);
    if (layerinfo) {
      layerinfo.forEach((layer, key) => {
        if (layer.visible) {
          mapViewUtils.showBaseLayer("mapPrint", key, true);
          this.fire("setShowLayer", { key });
        }
      });
    }
  }
  showBaseLayer(key, isShow) {
    mapViewUtils.showBaseLayer("mapPrint", key, isShow);
  }

  destroy() {
    this.off();
    mapViewUtils.offViewEvents("resetLayerDatas", this._loadedSync, this._mapTarget);
  }
}
