import Mitt from "@/common/_utils/mitt";
import { mapViewUtils } from "@/common/_utils/gis-utils";

export default class ScaleViewModel extends Mitt {
  _props = null;
  webMap = null;
  constructor(mapTarget) {
    super();
    this._props = { mapTarget };
    // 事件绑定this
    this._loadedAsync = this._loadedAsync.bind(this);    
    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {
    // 监听地图初始化完成事件    
    mapViewUtils.bindViewEvents("mounted", this._loadedAsync, this._props.mapTarget);   
  }

  _loadedAsync(e) {
    // 如果图层变化事件是自己触发的 则不继续执行 避免死循环
    if (e.eventTarget && e.eventTarget === this) {
      return;
    }
    let webMap = (this.webMap = e.target);
    this.fire("getWebMap", { webMap });
  } 

  destroy() {
    this.off();
  }
}
