import { h, createApp, resolveComponent, reactive } from "vue";

let dynamicContainerElem;

export const dynamicStore = reactive({
  modals: []
});

// 动态组件
const BaseDynamics = {  
  setup() {
    return () => {
      const { modals } = dynamicStore;
      return h(
        "div",
        {
          class: "kq-base-dynamics--scale"
        },
        {
          default: () =>
            modals.map(item => {           
              return h(resolveComponent("kq-2d-scale"), item);
            })
        }
      );
    };
  }
};

export const dynamicApp = createApp(BaseDynamics);

export function checkDynamic() {
  if (!dynamicContainerElem) {
    dynamicContainerElem = document.createElement("div");
    dynamicContainerElem.className = "kq-base-dynamics";
    document.body.appendChild(dynamicContainerElem);
    dynamicApp.mount(dynamicContainerElem);
  }
}
