import ScaleComponent from "./scale.js";
import ScaleViewModel from "./ScaleViewModel";
import { dynamicApp, dynamicStore, checkDynamic } from "./dynamics";

const ScaleController = {
  init: options => {
    return new Promise(resolve => {     
      dynamicStore.modals.push(options);
      checkDynamic();
    });
  }
};

export const Scale = Object.assign(ScaleComponent, {
  install: function (Vue) {
    dynamicApp.component(Scale.name, Scale);
    Vue.component(ScaleComponent.name, ScaleComponent);
    Vue.config.globalProperties.$Kq2dScale = ScaleController;
  }
});

export { Scale as default, ScaleViewModel };
