import Mitt from "@/common/_utils/mitt";
import { utils, mapViewUtils } from "@/common/_utils/gis-utils";

export default class ScaleLocationViewModel extends Mitt {
  _props = null;

  constructor(mapTarget) {
    super();
    this._props = { mapTarget };
    // 事件绑定this
    this._getScalesAsync = this._getScalesAsync.bind(this);
    this._getScalesSync = this._getScalesSync.bind(this);
    this._registerEvents();
  }

  /**
   * 注册事件
   */
  _registerEvents() {
    // 监听地图初始化完成事件
    // 异步
    mapViewUtils.bindViewEvents("mounted", this._getScalesAsync, this._props.mapTarget);
    // 同步
    utils.getWebMap(this._props.mapTarget, this._getScalesSync);
  }

  /**
   * 获取scales
   */
  _getScalesAsync(e) {
    // 如果图层变化事件是自己触发的 则不继续执行 避免死循环
    if (e.eventTarget && e.eventTarget === this) {
      return;
    }
    let scale = e.target.getScale();
    let webMap = e.target;
    this.fire("getScales", { scale, webMap });
  }
  _getScalesSync(e) {
    let scale = e.getScale();
    let webMap = e;
    this.fire("getScales", { scale, webMap });
  }
}
